/*--------------------------------------------------------------------------------------+
|
|    $RCSfile: file.tpl,v $
|   $Revision: 1.2 $
|       $Date: 1999/03/25 22:38:04 $
|     $Author:  $
|
| Copyright (c) 1999;  Bentley Systems, Inc., 685 Stockton Drive, 
|                      Exton PA, 19341-0678, USA.  All Rights Reserved.
|
| This program is confidential, proprietary and unpublished property of Bentley Systems 
| Inc. It may NOT be copied in part or in whole on any medium, either electronic or 
| printed, without the express written consent of Bentley Systems, Inc.
|
+--------------------------------------------------------------------------------------*/

// Compile: cl -GX -YX xltest.cpp 
//
// Assumes Office 97 has been installed in "C:\Program Files"
#ifndef TFJ_NO_XL_SHEET
#pragma warning(disable:4049)   // ignore "compiler limit : terminating line number emission"
#include <windows.h>
#include <shellapi.h>
#include <atlbase.h>

#pragma warning(disable:4146)   // Ignore "unary minus operator applied to unsigned type, result still unsigned"
#define IMPATTRS rename("DocumentProperties", "DocProps")
#import <C:\Program Files\Microsoft Office\Office\mso9.dll> IMPATTRS
#import <C:\Program Files\Common Files\Microsoft Shared\VBA\vbeext1.olb>
#import <C:\Program Files\Microsoft Office\Office\excel9.olb> IMPATTRS \
rename("DialogBox", "DialogBoxXL") rename("RGB", "RBG_XL") exclude("IFont") exclude("IPicture")
#pragma warning(default:4146)

#include <stdio.h>
#include <string.h>


#pragma comment (lib, "shell32")
#pragma comment (lib, "user32")

extern "C"
{
#define NO_BOOLEAN_TYPE

#include <mdl.h>
#include <basedefs.h>
#include <basetype.h>
#include <dloadlib.h>
#include <dlogids.h>
#include <dlogitem.h>
#include <dlmfuncs.h>
#include "xlrpt.h"

#include <msstrngl.fdf>
#include <dlmsys.fdf>

#include "xlrpt.fdf"
}


#define CONVERT_ColRowIndex(col, row, val)				    \
    {									    \
    char snot[50];							    \
    if (col < 26)							    \
	_snprintf(snot, sizeof snot, "%c%d", 'A'+col,row+1);		    \
    else								    \
	_snprintf(snot, sizeof snot, "%c%c%d", 'A'+(col/26), 'A'+(col%26),row+1);   \
    pSheet->Range[snot][snot]->Value = val;					    \



/*----------------------------------------------------------------------+
|								    	|
| Name:     dump_com_error						|
|								    	|
| Author:  Bentley Systems					3/99	    	|
|								    	|
+----------------------------------------------------------------------*/
void dump_com_error (_com_error &e)
    {
    char buf[1024];
    _bstr_t bstrSource(e.Source());
    _bstr_t bstrDescription(e.Description());

    _snprintf (buf, sizeof buf, 
	"COM error.\r\n"
	"\tCode = %08lx\r\n"
	"\tWCode = %04x\r\n"
	"\tCode meaning = %s\r\n"
	"\tSource = %S\r\n"
	"\tDescription = %S",
	e.Error(), e.WCode(),  e.ErrorMessage(), 
	(wchar_t*)bstrSource,
	(wchar_t*)bstrDescription);
    MessageBox(NULL, buf, "Excel Error", MB_OK);
    }


/*----------------------------------------------------------------------+
|								    	|
| Name:     convert_ColNumToLetter					|
|								    	|
| Author:   Bentley Systems					3/99	    	|
|								    	|
+----------------------------------------------------------------------*/
Private char * convert_ColNumToLetter
(
int     col
)
    {
    static char col_txt[8];
    if (col < 26)
	_snprintf(col_txt, sizeof col_txt, "%c", 'A'+col);
    else
	_snprintf(col_txt, sizeof col_txt, "%c%c", 'A'+(col/26), 'A'+(col%26));

    return  col_txt;
    }

/*----------------------------------------------------------------------+
|								    	|
| Name:     convert_ColRowIndex						|
|								    	|
| Author:   Bentley Systems					3/99	    	|
|								    	|
+----------------------------------------------------------------------*/
Private char * convert_ColRowIndex
(
int     col,
int     row
)
    {
    static char index_txt[50];
    char	*colP;

    colP = convert_ColNumToLetter (col);

    _snprintf(index_txt, sizeof index_txt, "%s%d", colP, row+1);

    return  index_txt;
    }
 
#else //TFJ_NO_XL_SHEET

extern "C"
{
#include <mdl.h>
#include <basedefs.h>
#include <basetype.h>
#include <dloadlib.h>
#include <dlogids.h>
#include <dlogitem.h>
#include <dlmfuncs.h>
#include "xlrpt.h"

#endif //TFJ_NO_XL_SHEET

/*-----------------*/
Public void xlSheetTest()
{
DWORD tid = GetCurrentThreadId();
    try {
        using namespace Excel;
        _ApplicationPtr pXL("Excel.Application");
        // The following line demonstrates calling a property-put method.
        // It translates to pXL->PutVisible(VARIANT_TRUE);
        pXL->Visible;// = true;
        // The following line demonstrates calling a property-get method.
        // It translates to pBooks = pXL->GetWorkbooks();
        WorkbooksPtr pBooks = pXL->Workbooks;
        _WorkbookPtr  pBook  = pBooks->Add((long)xlWorksheet);
        _WorksheetPtr pSheet = pXL->ActiveSheet;

RangePtr pRage = pSheet->Range["A1"]["A1"];

//VARIANT poop (pRage->Value);
pRage->Value = 101.0;

pSheet->Range["A1"]["B3"]->Value = 100.0;

	pSheet->Range["A1"]->Value = 100.0;


        // The following series of lines demonstrate how parameterized
        // properties can be accessed using array indexing syntax.
        pSheet->Range["A2:A2"]->Value = "North";
        pSheet->Range["A2"]->Value = "North";

        pSheet->Range["B2"]->Value = "South";
        pSheet->Range["C2"]->Value = "East";
        pSheet->Range["D2"]->Value = "West";
        pSheet->Range["A3"]->Value = 5.2;
        pSheet->Range["B3"]->Value = (long)10;
        pSheet->Range["C3"]->Value = (short)8;
        pSheet->Range["D3"]->Value = (float)20.0;
        Sleep(2000);
        RangePtr  pRange  = pSheet->Range["A2"]["D3"];
        SheetsPtr pCharts = pBook->Charts;
        _ChartPtr pChart  = pCharts->Add();
        pChart->ChartWizard((IDispatch*)pRange, (long)xl3DPie, 7L,
                            (long)xlRows, 1L, 0L, 2L, "Sales Percentages");
        Sleep(5000);
        //pBook->Saved = true;
        pXL->Quit();
    } catch(_com_error &e) {
        dump_com_error(e);
    }
    
}    


/*----------------------------------------------------------------------+
|								    	|
| Name:     xlSheet_create						|
|								    	|
| Author:   Bentley Systems 					3/99	    	|
|								    	|
+----------------------------------------------------------------------*/
Public nativeCode void xlSheet_create
(
xlSheetSpec *xlSpecP,		    /* array */
int	    numOfxlSheetSpec,
boolean     removeExistingSheets,
char	    *xlFileNameP,
boolean	    xlFileExist,
boolean     leaveActive
)
    {
#ifndef TFJ_NO_XL_SHEET
    if (xlSpecP == NULL)
	return;

    OleInitialize(NULL);

    int     needNew = FALSE;
    char    *indexP;
//xlSheetTest();
    try
	{
        using namespace Excel;
        _ApplicationPtr pXL("Excel.Application");
	if (pXL == NULL)
	    return;
        // The following line demonstrates calling a property-put method.
        // It translates to pXL->PutVisible(VARIANT_TRUE);
	/* if Visible is true then application will display on screen */
        pXL->Visible;// = leaveActive;

        // The following line demonstrates calling a property-get method.
        // It translates to pBooks = pXL->GetWorkbooks();
        WorkbooksPtr pBooks = pXL->Workbooks;
       //	WorkbooksPtr pBooks = pXL->getWorkbooks();

	_WorkbookPtr  pBook;


	if (!removeExistingSheets)
	    pBook = pBooks->Add((long)xlWorksheet);
	else
	    {
	    pBook = pBooks->Open (xlFileNameP);
	    needNew = TRUE;
	    }

        SheetsPtr pSheets = pBook->Sheets;

	StringList  *hiddenColListP = NULL;
	char	    memStr[16];
	int	    memberIndex;

	StringList  *currentSLP = NULL;
	char	    *stringP;
	char	    fst_col[8], lst_col[8], colRange[16];
	int	    num, numCols, size, i, j;
	int	    offsetCol, offsetRow;
	long	    *infoFieldP=NULL;

	for (num = 0; num < numOfxlSheetSpec; num++)

	{
	    currentSLP	= xlSpecP[num].strListP;
	    numCols	= xlSpecP[num].numCols;
	    offsetCol   = xlSpecP[num].offsetCol;
	    offsetRow   = xlSpecP[num].offsetRow;
	    if (currentSLP)
		{
		_WorksheetPtr pSheet;
		if (needNew)
		    pSheet = pSheets->Add();
		else
		    pSheet = pXL->ActiveSheet;

		needNew = TRUE;

		/* set the name of the sheet */
		pSheet->Name = xlSpecP[num].sheetName;

		size = (int) (mdlStringList_size (currentSLP) / numCols);

		for (i=0; i < size; i++)
		    {
		    for (j=0; j < numCols; j++)
			{
			mdlStringList_getMember (&stringP, &infoFieldP, currentSLP, i*numCols+j);
			if (!stringP)
			    continue;
			if (xlSpecP[num].byColumn)
			    indexP = convert_ColRowIndex (j + offsetCol, i + offsetRow);
			else
			    indexP = convert_ColRowIndex (i + offsetRow, j + offsetCol);
			
			pSheet->Range[indexP][indexP]->Value = stringP;

			if (xlSpecP[num].numInfoFields && infoFieldP)
			    {
			    if (-1L == infoFieldP[0])
				{
				if (NULL == hiddenColListP)
				    hiddenColListP = mdlStringList_create (0, 0);

				mdlStringList_insertMember ((long *)&memberIndex, hiddenColListP, -1, 1);
				_snprintf(memStr, sizeof memStr, "%d", j + offsetCol);
				mdlStringList_setMember (hiddenColListP, memberIndex, memStr, NULL);

				}
			    }
			}
		    }
		strcpy (fst_col, convert_ColRowIndex (0, 0));
		strcpy (lst_col, convert_ColRowIndex (j-1 + offsetCol, 0 + offsetRow));
		_snprintf(colRange, sizeof colRange, "%s:%s", fst_col, lst_col);

		/* fit the range to display all information */
		pSheet->Range[fst_col][lst_col]->EntireColumn->AutoFit ();

		if (NULL != hiddenColListP)
		    {
		    int		 previous = -1, colNum;
		    char	 *newValueP;
		    InteriorPtr  pInterior;
		    mdlStringList_sort (hiddenColListP, -1, TRUE, NULL);
		    size = mdlStringList_size (hiddenColListP);
		    for (i = 0; i < size ;i++ )
		    	{
			mdlStringList_getMember (&newValueP, NULL, hiddenColListP, i);
			colNum = atol (newValueP);
			if (colNum == previous)
			    continue;
			previous = colNum;

			if (xlSpecP[num].byColumn)
			    indexP = convert_ColRowIndex (colNum, 0);
			else
			    indexP = convert_ColRowIndex (0, colNum);

			if (xlSpecP[num].byColumn)
			    {
			    pSheet->Range[indexP][indexP]->EntireColumn->PutHidden (true);
			    /* get the property method for InteriorPtr*/
			    pInterior =  pSheet->Range[indexP][indexP]->EntireColumn->GetInterior ();
			    }
			else
			    {
			    pSheet->Range[indexP][indexP]->EntireRow->PutHidden (true);
			    /* get the property method for InteriorPtr*/
			    pInterior =  pSheet->Range[indexP][indexP]->EntireRow->GetInterior ();
			    }

			CComVariant colorIndex(15);
			pInterior->ColorIndex = colorIndex;

			CComVariant pattern(1);
			pInterior->Pattern = pattern;

			/* *pInterior->PatternColorIndex = "17"; // same thing as the below two lines */
			CComVariant patternColorIndex(17);
			pInterior->PatternColorIndex = patternColorIndex;
		    	}
		    }
		}
	    }

	if (!xlFileExist)
	    pBook->SaveAs(xlFileNameP, (long)xlWorkbookNormal, "", "", 0L,
		      1L, xlNoChange, (long)xlLocalSessionChanges, 1L, 0L, 0L);
	else
	    pBook->Save	();

        pBook->Saved;// = true;

	if (!leaveActive)
	    pXL->Quit();
	}

    catch (_com_error &e)
	{
	dump_com_error(e);
	}

    OleUninitialize();
#endif //TFJ_NO_XL_SHEET
    }
				   


/*----------------------------------------------------------------------+
|								    	|
| Name:     xlSheet_testExcelEXE					|
|								    	|
| Author:   Bentley Systems					3/99	    	|
|								    	|
+----------------------------------------------------------------------*/
Public nativeCode int xlSheet_testExcelEXE
(
char    *fullFileNameP
)   
    {
#ifndef TFJ_NO_XL_SHEET
    HINSTANCE   hi;
    char	d2[MAX_PATH];

    hi = FindExecutable (fullFileNameP, NULL, d2);
    if ((int)hi > 32)
	return  TRUE;
#endif //TFJ_NO_XL_SHEET
    return  FALSE;
    }

#ifdef TFJ_NO_XL_SHEET
}
#endif //TFJ_NO_XL_SHEET

extern "C"
    {
/*----------------------------------------------------------------------+
|								        |
| Name:     initialize   						|
|								        |
| Author:   MarkAnderson 				05/100 		|
|								        |
+----------------------------------------------------------------------*/
__declspec(dllexport) int initialize
	(
	char	    *filenameP,
	char	    *taskIDP,
	void	    *localDlmID,    /*  Uniquely identifies the DLM */
	ULong	     version	    /*  Value is taken from the DLM Spec Source */
	)
	    {
	    static  int calledBefore;

	    if (version > 0x500)
		{
		dlmSystem_displayError ("lib: version must be 5.0.0 or less.");
		/*  Reject the load request */
		return -1;
		}

	    if (calledBefore)
		return 0;

	    calledBefore = 1;

	    return 0;
	    }

    
    }